Public Class LaborPanel

    Private WithEvents m_Source As LaborTextBuilder
    Private m_Controls As New List(Of Control)

    Property Source() As LaborTextBuilder
        Get
            Return m_Source
        End Get
        Set(ByVal value As LaborTextBuilder)
            If m_Source IsNot value Then
                Me.Controls.Clear()
                m_Controls.Clear()
                m_Source = value
                If m_Source IsNot Nothing Then
                    For Each Grp As LaborTextGruppe In m_Source.Gruppen
                        m_Controls.Add(Grp.CreateControl)
                    Next
                    For Each xCtl As ILaborWertControl In m_Controls
                        xCtl.Panel = Me
                    Next
                    'm_Controls.Reverse()
                    Me.Controls.AddRange(m_Controls.ToArray)
                    TabStoppsSortieren()
                    'm_Controls.Reverse()
                End If
                'Invalidate()

            End If
        End Set
    End Property


    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)

        'Benutzerdefinierten Zeichnungscode hier einfügen
        ControlPaint.DrawVisualStyleBorder(e.Graphics, New Rectangle(0, 0, Me.Width - 1, Me.Height - 1))
    End Sub


    Public Sub New()

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.ResizeRedraw = True
    End Sub

    Private Sub m_Source_Changed() Handles m_Source.Changed
        Dim SCtls As New List(Of ILaborWertControl)

        For Each Ctl As Control In Me.Controls
            Dim SCtl As ILaborWertControl = Ctl
            Me.Controls.SetChildIndex(Ctl, m_Source.Gruppen.IndexOf(SCtl.Source))
            'SCtls.Add(SCtl)
        Next

        For Each xCtl As ILaborWertControl In m_Controls
            xCtl.RefreshButtons()
        Next
        TabStoppsSortieren()
    End Sub

    Public Sub SetButtonsEnabled(ByVal ParentControl As Control, ByVal ChildControl As Control)
        For Each xCtl As ILaborWertControl In m_Controls
            xCtl.HideButtons(ParentControl, ChildControl)
        Next
    End Sub
    Private Sub TabStoppsSortieren()
        Dim Zaehler As Integer = 0
        For Each Ctl As Control In Me.Controls
            Ctl.TabIndex = Zaehler
            Zaehler += 1
        Next
    End Sub
End Class
